searchNodes=[{"doc":"Mix task to download database file(s) from your command line. Arguments When run without arguments the task will display the target directory for the downloaded files and will ask for confirmation before downloading. --force : skip confirmation before downloading --quiet : silences task output (does not imply --force !) Informational README If you are using the default databases from the default remote location an informational README with the filename ua_inspector.readme.md will be placed next to the downloaded file(s). Inside you will find a link to the original database source. The creation of this file can be deactivated by configuration: config :ua_inspector , skip_download_readme : true","ref":"Mix.Tasks.UaInspector.Download.html","title":"Mix.Tasks.UaInspector.Download","type":"task"},{"doc":"User agent parser library. Preparation Verify your supervision setup according to UAInspector.Supervisor Revise the default configuration values of UAInspector.Config and adjust to your project/environment where necessary Download a copy of the database files as outlined in UAInspector.Downloader Please re-download (or otherwise update your copy of) the database if the default :remote_release in UAInspector.Config changes. Usage The map key :user_agent will hold the unmodified passed user agent. If the device type cannot be determined a &quot;desktop&quot; device type will be assumed (and returned). Both :brand and :model are set to :unknown . When a bot agent is detected the result with be a UAInspector.Result.Bot struct instead of UAInspector.Result . Basic User Agent Lookup iex&gt; UAInspector . parse ( &quot;Mozilla/5.0 (iPad; CPU OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53&quot; ) % UAInspector.Result { browser_family : &quot;Safari&quot; , client : % UAInspector.Result.Client { engine : &quot;WebKit&quot; , engine_version : &quot;537.51.1&quot; , name : &quot;Mobile Safari&quot; , type : &quot;browser&quot; , version : &quot;7.0&quot; } , device : % UAInspector.Result.Device { brand : &quot;Apple&quot; , model : &quot;iPad&quot; , type : &quot;tablet&quot; } , os : % UAInspector.Result.OS { name : &quot;iOS&quot; , platform : :unknown , version : &quot;7.0.4&quot; } , os_family : &quot;iOS&quot; , user_agent : &quot;Mozilla/5.0 (iPad; CPU OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53&quot; } Lookup with Additional Client Hints iex&gt; client_hints = UAInspector.ClientHints . new ( [ ...&gt; { &quot;sec-ch-ua&quot; , ~S(&quot; Not A;Brand&quot;;v=&quot;99&quot;, &quot;Chromium&quot;;v=&quot;95&quot;, &quot;Microsoft Edge&quot;;v=&quot;95&quot;) } , ...&gt; { &quot;sec-ch-ua-mobile&quot; , &quot;?0&quot; } , ...&gt; { &quot;sec-ch-ua-platform&quot; , &quot;Windows&quot; } , ...&gt; { &quot;sec-ch-ua-platform-version&quot; , &quot;14.0.0&quot; } ...&gt; ] ) iex&gt; UAInspector . parse ( &quot;Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.69 Safari/537.36 Edg/95.0.1020.44&quot; , client_hints ) % UAInspector.Result { browser_family : &quot;Internet Explorer&quot; , client : % UAInspector.Result.Client { engine : &quot;Blink&quot; , engine_version : &quot;95.0.4638.69&quot; , name : &quot;Microsoft Edge&quot; , type : &quot;browser&quot; , version : &quot;95.0.1020.44&quot; } , device : % UAInspector.Result.Device { brand : :unknown , model : :unknown , type : &quot;desktop&quot; } , os : % UAInspector.Result.OS { name : &quot;Windows&quot; , platform : &quot;x64&quot; , version : &quot;10&quot; } , os_family : &quot;Windows&quot; , user_agent : &quot;Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.69 Safari/537.36 Edg/95.0.1020.44&quot; } iex&gt; client_hints = UAInspector.ClientHints . new ( [ { &quot;x-requested-with&quot; , &quot;org.telegram.messenger&quot; } ] ) iex&gt; UAInspector . parse ( &quot;Mozilla/5.0 (Linux; Android 11; Pixel 3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.131 Mobile Safari/537.36&quot; , client_hints ) % UAInspector.Result { browser_family : :unknown , client : % UAInspector.Result.Client { engine : :unknown , engine_version : :unknown , name : &quot;Telegram&quot; , type : &quot;mobile app&quot; , version : :unknown } , device : % UAInspector.Result.Device { brand : &quot;Google&quot; , model : &quot;Pixel 3&quot; , type : &quot;smartphone&quot; } , os : % UAInspector.Result.OS { name : &quot;Android&quot; , platform : :unknown , version : &quot;11&quot; } , os_family : &quot;Android&quot; , user_agent : &quot;Mozilla/5.0 (Linux; Android 11; Pixel 3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.131 Mobile Safari/537.36&quot; } Bot Result iex&gt; UAInspector . parse ( &quot;Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36&quot; ) % UAInspector.Result.Bot { category : &quot;Search bot&quot; , name : &quot;Googlebot&quot; , producer : % UAInspector.Result.BotProducer { name : &quot;Google Inc.&quot; , url : &quot;http://www.google.com&quot; } , url : &quot;http://www.google.com/bot.html&quot; , user_agent : &quot;Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36&quot; } iex&gt; UAInspector . parse ( &quot;generic crawler agent&quot; ) % UAInspector.Result.Bot { category : :unknown , name : &quot;Generic Bot&quot; , producer : % UAInspector.Result.BotProducer { name : :unknown , url : :unknown } , url : :unknown , user_agent : &quot;generic crawler agent&quot; } Unknown User Agent iex&gt; UAInspector . parse ( &quot;--- undetectable ---&quot; ) % UAInspector.Result { browser_family : :unknown , client : :unknown , device : :unknown , os : :unknown , os_family : :unknown , user_agent : &quot;--- undetectable ---&quot; }","ref":"UAInspector.html","title":"UAInspector","type":"module"},{"doc":"Checks if a user agent is a known bot.","ref":"UAInspector.html#bot?/2","title":"UAInspector.bot?/2","type":"function"},{"doc":"Checks if a user agent is a desktop device.","ref":"UAInspector.html#desktop?/2","title":"UAInspector.desktop?/2","type":"function"},{"doc":"Checks if a user agent is a HbbTV and returns its version if so.","ref":"UAInspector.html#hbbtv?/2","title":"UAInspector.hbbtv?/2","type":"function"},{"doc":"Checks if a user agent is a mobile device.","ref":"UAInspector.html#mobile?/2","title":"UAInspector.mobile?/2","type":"function"},{"doc":"Parses a user agent.","ref":"UAInspector.html#parse/2","title":"UAInspector.parse/2","type":"function"},{"doc":"Parses a user agent without checking for bots.","ref":"UAInspector.html#parse_client/2","title":"UAInspector.parse_client/2","type":"function"},{"doc":"Checks if UAInspector is ready to perform lookups. The true == ready? definition is made on the assumption that if there is at least one entry in all databases then lookups can be performed. Checking the state is done using the currently active databases. Any potentially concurrent reload requests are not considered.","ref":"UAInspector.html#ready?/0","title":"UAInspector.ready?/0","type":"function"},{"doc":"Reloads all databases. You can pass [async: true|false] to define if the reload should happen in the background (default!) or block your calling process until completed.","ref":"UAInspector.html#reload/1","title":"UAInspector.reload/1","type":"function"},{"doc":"Checks if a user agent is a ShellTV.","ref":"UAInspector.html#shelltv?/2","title":"UAInspector.shelltv?/2","type":"function"},{"doc":"Parse and store client hint headers for usage in device detection.","ref":"UAInspector.ClientHints.html","title":"UAInspector.ClientHints","type":"module"},{"doc":"Parse headers into a new client hint struct. All headers are expected in dash-case (lowercase with dashes) format. Last header (if multiple possible) will be used for the result.","ref":"UAInspector.ClientHints.html#new/1","title":"UAInspector.ClientHints.new/1","type":"function"},{"doc":"","ref":"UAInspector.ClientHints.html#t:t/0","title":"UAInspector.ClientHints.t/0","type":"type"},{"doc":"Module to simplify access to configuration values with default values. There should be no configuration required to start using :ua_inspector if you rely on the default values: remote_database = &quot;https://raw.githubusercontent.com/matomo-org/device-detector/6.0.6/regexes&quot; remote_shortcode = &quot;https://raw.githubusercontent.com/matomo-org/device-detector/6.0.6&quot; config :ua_inspector , database_path : Application . app_dir ( :ua_inspector , &quot;priv&quot; ) , http_opts : [ ] , remote_path : [ bot : remote_database , browser_engine : remote_database &lt;&gt; &quot;/client&quot; , client : remote_database &lt;&gt; &quot;/client&quot; , client_hints : remote_database &lt;&gt; &quot;/client/hints&quot; , device : remote_database &lt;&gt; &quot;/device&quot; , os : remote_database , short_code_map : remote_shortcode , vendor_fragment : remote_database ] , remote_release : &quot;6.0.6&quot; , startup_silent : false , startup_sync : true , yaml_file_reader : { :yamerl_constr , :file , [ [ :str_node_as_binary ] ] } The default :database_path is evaluated at runtime and not compiled into a release! How to Configure There are two ways to change the configuration values with the preferred way depending on your environment and personal taste. Static Configuration If you can ensure the configuration are static and not dependent on i.e. the server your application is running on, you can use a static approach by modifying your config.exs file: config :ua_inspector , database_path : &quot;/path/to/ua_inspector/databases&quot; Dynamic Configuration If a compile time configuration is not possible or does not match the usual approach taken in your application you can use a runtime approach. This is done by defining an initializer module that will automatically be called by UAInspector.Supervisor upon startup/restart. The configuration is expected to consist of a {mod, fun} or {mod, fun, args} tuple: # {mod, fun} config :ua_inspector , init : { MyInitModule , :my_init_mf } # {mod, fun, args} config :ua_inspector , init : { MyInitModule , :my_init_mfargs , [ :foo , :bar ] } defmodule MyInitModule do @spec my_init_mf ( ) :: :ok def my_init_mf ( ) , do : my_init_mfargs ( :foo , :bar ) @spec my_init_mfargs ( atom , atom ) :: :ok def my_init_mfargs ( :foo , :bar ) do priv_dir = Application . app_dir ( :my_app , &quot;priv&quot; ) Application . put_env ( :ua_inspector , :database_path , priv_dir ) end end The function is required to always return :ok . Startup Behaviour By default the database files will be read during application startup. You can change this behaviour by configuring an immediate asynchronous reload: config :ua_inspector , startup_sync : false This can lead to the first parsing calls to work with an empty database and therefore not return the results you expect. Starting Silently When starting the application you will receive messages via Logger.info/1 if a database file fails to be parsed or has no entries. If you want to prevent these messages you can configure the startup the be completely silent: config :ua_inspector , startup_silent : true Database Configuration Configuring the database to use can be done using two related values: :database_path :remote_path The :database_path is the directory to look for when loading the databases. It is also the place where UAInspector.Downloader stores a downloaded copy. For the time being the detailed list of database files is not configurable. This is a major caveat for personal database copies and short code mappings (they have additional path information appended to the base). This behaviour is subject to change. The full configuration for remote paths contains the following values: config :ua_inspector , remote_path : [ bot : &quot;http://example.com&quot; , browser_engine : &quot;http://example.com&quot; , client : &quot;http://example.com&quot; , client_hints : &quot;http://example.com&quot; , device : &quot;http://example.com&quot; , os : &quot;http://example.com&quot; , short_code_map : &quot;http://example.com&quot; , vendor_fragment : &quot;http://example.com&quot; ] Default Database Release Version If you are using the default configuration the release &quot;6.0.6&quot; will be used. You can specify a different version/tag/release to be used: config :ua_inspector , remote_release : &quot;v1.0.0&quot; Please be aware that using a non-default release can lead to unexpected results based on the specific changes between the releases. If the default release changes (expect this to be the case with every release of UAInspector) you should download a new copy of the database and/or update your own release configuration. As the list of used files or special in-code detections can change with each release there may otherwise be unexpected messages during application startup or incorrect results from agent detection. Download Configuration Using the default configuration all download requests for your database files are done using :hackney . To pass custom configuration values to hackney you can use the key :http_opts : # increase download timeout to 10 seconds (default: 5 seconds) config :ua_inspector , http_opts : [ recv_timeout : 10_000 ] Please look at :hackney.request/5 for a complete list of available options. If you want to change the library used to download the databases you can configure a module implementing the UAInspector.Downloader.Adapter behaviour: config :ua_inspector , downloader_adapter : MyDownloaderAdapter YAML File Reader Configuration By default the library :yamerl will be used to read and decode the YAML database files. You can configure this reader to be a custom module: config :ua_inspector , yaml_file_reader : { module , function } config :ua_inspector , yaml_file_reader : { module , function , extra_args } The configured module will receive the file to read as the first argument with any optionally configured extra arguments after that.","ref":"UAInspector.Config.html","title":"UAInspector.Config","type":"module"},{"doc":"Returns the configured database path. If the path is not defined the priv dir of :ua_inspector as returned by Application.app_dir(:ua_inspector, &quot;priv&quot;) will be used.","ref":"UAInspector.Config.html#database_path/0","title":"UAInspector.Config.database_path/0","type":"function"},{"doc":"Returns the remote url of a database file.","ref":"UAInspector.Config.html#database_url/2","title":"UAInspector.Config.database_url/2","type":"function"},{"doc":"Returns whether the remote database (at least one type) matches the default.","ref":"UAInspector.Config.html#default_remote_database?/0","title":"UAInspector.Config.default_remote_database?/0","type":"function"},{"doc":"Returns the configured downloader adapter module. The modules is expected to adhere to the behaviour defined in UAInspector.Downloader.Adapter .","ref":"UAInspector.Config.html#downloader_adapter/0","title":"UAInspector.Config.downloader_adapter/0","type":"function"},{"doc":"Provides access to configuration values with optional environment lookup.","ref":"UAInspector.Config.html#get/2","title":"UAInspector.Config.get/2","type":"function"},{"doc":"Calls the optionally configured init method.","ref":"UAInspector.Config.html#init_env/0","title":"UAInspector.Config.init_env/0","type":"function"},{"doc":"Returns the currently configured remote release version.","ref":"UAInspector.Config.html#remote_release/0","title":"UAInspector.Config.remote_release/0","type":"function"},{"doc":"Returns the {mod, fun, extra_args} to be used when reading a YAML file.","ref":"UAInspector.Config.html#yaml_file_reader/0","title":"UAInspector.Config.yaml_file_reader/0","type":"function"},{"doc":"This supervisor module takes care of starting the required database storage processes. It is automatically started with the :ua_inspector application. If you do not want to automatically start the application itself you can adapt your configuration for a more manual supervision approach. Instead of adding :ua_inspector to your :applications list or using the automatic discovery you need to add it to your :included_applications : def application do [ included_applications : [ # ... :ua_inspector , # ... ] ] end That done you can add UAInspector.Supervisor to your hierarchy: children = [ # ... UAInspector.Supervisor , # .. ]","ref":"UAInspector.Supervisor.html","title":"UAInspector.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"UAInspector.Supervisor.html#child_spec/1","title":"UAInspector.Supervisor.child_spec/1","type":"function"},{"doc":"Fetches copies of the configured database files. All files will be stored in the configured database path with the default setting being the result of Application.app_dir(:ua_inspector, &quot;priv&quot;) . Please consult UAInspector.Config for details on database configuration. Mix Task Please see Mix.Tasks.UaInspector.Download if you are interested in using a mix task to obtain your database files.","ref":"UAInspector.Downloader.html","title":"UAInspector.Downloader","type":"module"},{"doc":"Performs download of all files.","ref":"UAInspector.Downloader.html#download/0","title":"UAInspector.Downloader.download/0","type":"function"},{"doc":"Performs download of configured database files and short code maps.","ref":"UAInspector.Downloader.html#download/1","title":"UAInspector.Downloader.download/1","type":"function"},{"doc":"Behaviour for modules used by the downloader.","ref":"UAInspector.Downloader.Adapter.html","title":"UAInspector.Downloader.Adapter","type":"behaviour"},{"doc":"Reads a database file from a remote location and returns its contents.","ref":"UAInspector.Downloader.Adapter.html#c:read_remote/1","title":"UAInspector.Downloader.Adapter.read_remote/1","type":"callback"},{"doc":"Result struct.","ref":"UAInspector.Result.html","title":"UAInspector.Result","type":"module"},{"doc":"","ref":"UAInspector.Result.html#t:t/0","title":"UAInspector.Result.t/0","type":"type"},{"doc":"Bot result struct.","ref":"UAInspector.Result.Bot.html","title":"UAInspector.Result.Bot","type":"module"},{"doc":"","ref":"UAInspector.Result.Bot.html#t:t/0","title":"UAInspector.Result.Bot.t/0","type":"type"},{"doc":"Bot producer result struct.","ref":"UAInspector.Result.BotProducer.html","title":"UAInspector.Result.BotProducer","type":"module"},{"doc":"","ref":"UAInspector.Result.BotProducer.html#t:t/0","title":"UAInspector.Result.BotProducer.t/0","type":"type"},{"doc":"Client result struct.","ref":"UAInspector.Result.Client.html","title":"UAInspector.Result.Client","type":"module"},{"doc":"","ref":"UAInspector.Result.Client.html#t:t/0","title":"UAInspector.Result.Client.t/0","type":"type"},{"doc":"Device result struct.","ref":"UAInspector.Result.Device.html","title":"UAInspector.Result.Device","type":"module"},{"doc":"","ref":"UAInspector.Result.Device.html#t:t/0","title":"UAInspector.Result.Device.t/0","type":"type"},{"doc":"Operating system result struct.","ref":"UAInspector.Result.OS.html","title":"UAInspector.Result.OS","type":"module"},{"doc":"","ref":"UAInspector.Result.OS.html#t:t/0","title":"UAInspector.Result.OS.t/0","type":"type"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Bug fixes Devices containing (lite) TV in their agent are now properly identified as TV devices if more detailed information is not available","ref":"changelog.html#v3-1-1-2023-02-20","title":"Changelog - v3.1.1 (2023-02-20)","type":"extras"},{"doc":"Enhancements Allow checking if a user agent is a known desktop device using UAInspector.desktop?/1 Allow checking if a user agent is a known mobile device using UAInspector.mobile?/1 Default upstream database version is now v6.0.6 Parser results can be passed directly to UAInspector.bot?/1 , UAInspector.hbbtv?/1 , and UAInspector.shelltv?/1 Added support to use client hint headers for improved detection Upstream improvements to detect engine versions of &quot;Blink&quot; type browsers have been integrated Upstream improvements to detect ShellTV devices have been integrated Upstream improvements to detect x64 devices using Windows have been integrated Upstream improvements to detect generic TV devices have been integrated","ref":"changelog.html#v3-1-0-2023-02-12","title":"Changelog - v3.1.0 (2023-02-12)","type":"extras"},{"doc":"Enhancements Default upstream database version is now 5.0.5","ref":"changelog.html#v3-0-1-2022-03-08","title":"Changelog - v3.0.1 (2022-03-08)","type":"extras"},{"doc":"Enhancements Default upstream database version is now 5.0.4 If a database or short code map contains no (zero) entries during startup/reload a Logger.info/1 will be sent unless startup_silent = true is configured Backwards incompatible changes Minimum required Elixir version is now ~&gt; 1.9 The (default) :hackney download adapter will now only accept responses with &quot;200 OK&quot;. Depending on your environment it could be required to configure following redirects using http_opts: [follow_redirect: true]","ref":"changelog.html#v3-0-0-2022-03-06","title":"Changelog - v3.0.0 (2022-03-06)","type":"extras"},{"doc":"Default download database version has been pinned to &quot;release 3.13.1&quot; after major changes in the upstream sources ( matomo-org/device-detector moving towards a new major release). There will be a new major version of ua_inspector with a rebuilt database support for matomo-org/device-detector@v4.x and/or a separate database built upon these sources to simplify future upgrades. Enhancements Upstream improvements to detect engine versions of &quot;Gecko&quot; type browsers have been integrated Bug fixes Brand names are now always returned as strings (as expected), even if parsed as numbers from the YAML database","ref":"changelog.html#v2-2-0-2020-10-29","title":"Changelog - v2.2.0 (2020-10-29)","type":"extras"},{"doc":"Enhancements New &quot;desktop notebook&quot; devices are detected Upstream improvements to detect mobile apps using Chrome have been integrated","ref":"changelog.html#v2-1-0-2020-08-17","title":"Changelog - v2.1.0 (2020-08-17)","type":"extras"},{"doc":"Enhancements Detection will now make use of &quot;browser families&quot; to match upstream improvements for Chrome based devices If detectable the &quot;browser family&quot; of a client is now available as :browser_family in the result struct If detectable the &quot;operating system family&quot; of a client is now available as :os_family in the result struct Bug fixes The mix download task should no longer start unnecessary applications ( #19 ) Backwards incompatible changes Minimum required elixir version is now ~&gt; 1.7 Several deprecated functions have been removed completely: UAInspector.Downloader.prepare_database_path/0 UAInspector.Downloader.read_remote/0 UAInspector.Downloader.README.path_local/0 UAInspector.Downloader.README.path_priv/0 Startup is now done with a blocking database load by default","ref":"changelog.html#v2-0-0-2020-05-29","title":"Changelog - v2.0.0 (2020-05-29)","type":"extras"},{"doc":"Enhancements Warnings when starting without a database available can be silenced Bug fixes The mix download task now works properly with initializer modules ( #18 )","ref":"changelog.html#v1-2-0-2019-08-10","title":"Changelog - v1.2.0 (2019-08-10)","type":"extras"},{"doc":"Enhancements Configuring startup_sync: true allows you to ensure a synchronous database load is attempted before allowing to parse user agents Database entries are now stored in a single named table instead of using an intermediate reference table Output of mix task ua_inspector.download can be prevented by passing --quiet upon invocation. This does NOT imply --force and will still ask for confirmation Passing async: false to UAInspector.reload/1 allows you to block your calling process until the reload has finished The library used to download the database files can be changed by configuring a module implementing the UAInspector.Downloader.Adapter behaviour The library used to read YAML files can be changed by using the :yaml_file_reader configuration Bug fixes Matching the documentation the informational README file created by the downloader will now only be created when using the mix task Deprecations Several functions are now declared internal and will result in a Logger.info/1 message when called until they will be eventually removed: UAInspector.Downloader.prepare_database_path/0 UAInspector.Downloader.read_remote/0 UAInspector.Downloader.README.path_local/0 UAInspector.Downloader.README.path_priv/0","ref":"changelog.html#v1-1-0-2019-07-13","title":"Changelog - v1.1.0 (2019-07-13)","type":"extras"},{"doc":"Ownership has been transferred to the elixir-inspector organisation Enhancements Documentation is now available inline ( @moduledoc , ...) with the README.md file targeting the repository (development) instead of releases The default database path has been set to Application.app_dir(:ua_inspector, &quot;priv&quot;) Backwards incompatible changes Internal parser process pooling has been removed. If you require pooling you need to manually wrap UAInspector.parse/1 (and related functions) Minimum required elixir version is now ~&gt; 1.5 Support for {:system, var} configuration has been removed The deprecated mix tasks ua_inspector.download.databases and ua_inspector.download.short_code_maps have been removed","ref":"changelog.html#v1-0-0-2019-04-20","title":"Changelog - v1.0.0 (2019-04-20)","type":"extras"},{"doc":"Enhancements Initializer modules can be defined with additional arguments by using {mod, fun, args} When using the default database you can now set a :remote_release to be used for downloading. The default is &quot;master&quot; but any valid commit from the upstream source is allowed Deprecations Accessing the system environment by configuring {:system, var} or {:system, var, default} will now result in a Logger.info/1 message and will stop working in a future release The download tasks ua_inspector.download.databases and ua_inspector.download.short_code_maps are now deprecated and will be removed in a future release","ref":"changelog.html#v0-20-0-2019-03-10","title":"Changelog - v0.20.0 (2019-03-10)","type":"extras"},{"doc":"Bug fixes Short code maps are now stored in the correct file encoding ( UTF-8 ) to allow parsing short code maps with characters like umlauts ( #15 )","ref":"changelog.html#v0-19-2-2019-02-12","title":"Changelog - v0.19.2 (2019-02-12)","type":"extras"},{"doc":"Enhancements The (soft) deprecated download tasks ua_inspector.download.databases and ua_inspector.download.short_code_maps are no longer displayed in the output of mix help","ref":"changelog.html#v0-19-1-2019-01-05","title":"Changelog - v0.19.1 (2019-01-05)","type":"extras"},{"doc":"Enhancements All database files (parser databases and short code maps) can be downloaded using a single mix task ua_inspector.download Downloading the databases ensures hackney is started to allow calling mix run --no-start -e &quot;UAInspector.Downloader.download()&quot; Finding the data table is now done via a named lookup table instead of calling the database state server If you need to check if all databases are loaded (i.e. &quot;no longer empty&quot;) you can use UAInspector.ready?/0 OS Families are no longer hardcoded inside Util.OS but read from the original source and stored in a short code map OS Families used for desktop detection are no longer hardcoded inside Util.OS but read from the original source and stored in a short code map Reloading will now issue a warning if no database path is configured while resuming operation with an empty database Soft deprecations (no warnings) The individual download tasks for databases and short code maps have been removed from the documentation. They are still completely functional but will eventually be removed after a proper deprecation phase","ref":"changelog.html#v0-19-0-2019-01-03","title":"Changelog - v0.19.0 (2019-01-03)","type":"extras"},{"doc":"Enhancements Configuration can be done on supervisor (re-) start or when running the mix download tasks by setting a {mod, fun} tuple for the config key :init . This method will be called without arguments. Old data tables are deleted with a configurable delay after reloading to avoid race conditions (and the resulting empty lookup responses) Bug fixes ETS tables of short code maps are now properly cleaned after reload Soft deprecations (no warnings) Support for {:system, &quot;ENV_VARIABLE&quot;} configuration has been removed from the documentation. It will eventually be removed completely after a proper deprecation phase","ref":"changelog.html#v0-18-0-2018-08-15","title":"Changelog - v0.18.0 (2018-08-15)","type":"extras"},{"doc":"Enhancements References to piwik (like database URLs) have been updated to reflect the rename to matomo","ref":"changelog.html#v0-17-0-2018-02-18","title":"Changelog - v0.17.0 (2018-02-18)","type":"extras"},{"doc":"Bug fixes Broken module naming for the mix download tasks has been fixed ( #12 )","ref":"changelog.html#v0-16-1-2018-01-17","title":"Changelog - v0.16.1 (2018-01-17)","type":"extras"},{"doc":"Backwards incompatible changes Minimum required elixir version is now ~&gt; 1.3","ref":"changelog.html#v0-16-0-2018-01-05","title":"Changelog - v0.16.0 (2018-01-05)","type":"extras"},{"doc":"Bug fixes Broken module naming for the mix download tasks has been fixed ( #12 )","ref":"changelog.html#v0-15-1-2018-01-17","title":"Changelog - v0.15.1 (2018-01-17)","type":"extras"},{"doc":"Enhancements All databases can be reloaded (asynchronously) using UAInspector.reload/0 Supervision can now be done without starting the application ( #8 ) The database downloader has been promoted to a directly usable module Bug fixes If a device has no type configured in the database previously nil was returned instead of the expected :unknown","ref":"changelog.html#v0-15-0-2017-12-30","title":"Changelog - v0.15.0 (2017-12-30)","type":"extras"},{"doc":"Enhancements Empty user agents ( &quot;&quot; or nil ) now return a result without performing an actual lookup. By definition an empty user agent is never detected as a bot System environment configuration can set an optional default value to be used if the environment variable is unset Bug fixes Properly handles nil values passed to the lookup functions ( #7 )","ref":"changelog.html#v0-14-0-2017-05-31","title":"Changelog - v0.14.0 (2017-05-31)","type":"extras"},{"doc":"Enhancements Engine versions are extracted Remote url of database files is now configurable. Due to naming changes a complete re-download is necessary Remote url of short code map files is now configurable","ref":"changelog.html#v0-13-0-2016-09-08","title":"Changelog - v0.13.0 (2016-09-08)","type":"extras"},{"doc":"Enhancements Database downloads are done using hackney in order to prepare an upcoming auto-update feature If the initial load of a database (during process initialisation) fails a message will be sent through Logger.info/1 If the initial load of a short code map (during process initialisation) fails a message will be sent through Logger.info/1 Backwards incompatible changes Completely unknown devices now yield :unknown instead of a struct with all values set to :unknown Downloads are now done using :hackney instead of mix . This may force you to manually reconfigure the client Minimum required elixir version is now ~&gt; 1.2 Minimum required erlang version is now ~&gt; 18.0","ref":"changelog.html#v0-12-0-2016-08-18","title":"Changelog - v0.12.0 (2016-08-18)","type":"extras"},{"doc":"Bug fixes Properly handles short code map files after upstream changes","ref":"changelog.html#v0-11-1-2016-04-02","title":"Changelog - v0.11.1 (2016-04-02)","type":"extras"},{"doc":"Enhancements Databases are reloaded if a storage process gets restarted HbbTV version can be fetched using hbbtv?/1 Path can be configured by accessing the system environment ( #5 ) Short code mappings are reloaded if a storage process gets restarted","ref":"changelog.html#v0-11-0-2016-03-28","title":"Changelog - v0.11.0 (2016-03-28)","type":"extras"},{"doc":"Bug fixes Fixes problems with mix tasks under case insensitive file systems","ref":"changelog.html#v0-10-0-2015-11-10","title":"Changelog - v0.10.0 (2015-11-10)","type":"extras"},{"doc":"Enhancements Convenience method to check if user agent belongs to a bot ( bot?/1 ) Convenience method to parse without checking for bots ( parse_client/1 ) Operating system platform included in result","ref":"changelog.html#v0-9-0-2015-10-17","title":"Changelog - v0.9.0 (2015-10-17)","type":"extras"},{"doc":"Enhancements Bots are included in the detection Short code mappings are fetched and parsed on demand Backwards incompatible changes Short code maps are no longer included in the repository Renamed mix task databases.download to download.databases","ref":"changelog.html#v0-8-0-2015-07-09","title":"Changelog - v0.8.0 (2015-07-09)","type":"extras"},{"doc":"Enhancements Dependencies not used in production builds are marked as optional Displays expanded download path for mix ua_inspector.databases.download Verification script now automatically downloads database files Worker pool options are no longer defined at compile time Backwards incompatible changes Pool configuration is now expected to be a Keyword.t","ref":"changelog.html#v0-7-0-2015-05-31","title":"Changelog - v0.7.0 (2015-05-31)","type":"extras"},{"doc":"Initial Release","ref":"changelog.html#v0-6-0-2015-04-06","title":"Changelog - v0.6.0 (2015-04-06)","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"User agent parser library.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"To use UAInspector with your projects, edit your mix.exs file and add the required dependencies: defp deps do [ # ... { :ua_inspector , &quot;~&gt; 3.0&quot; } , # ... ] end If you want to use a manual supervision approach (without starting the application) please look at the inline documentation of UAInspector.Supervisor .","ref":"readme.html#package-setup","title":"Overview - Package Setup","type":"extras"},{"doc":"Out of the box the default database files will be stored in the :priv_dir of :ua_inspector . Both the database sources and path used can be changed. For a detailed list of available configuration options please consult UAInspector.Config .","ref":"readme.html#application-configuration","title":"Overview - Application Configuration","type":"extras"},{"doc":"Database Download You need to obtain a copy of the configured databases by calling either mix ua_inspector.download from the command line or UAInspector.Downloader.download/0 from within your application. Refer to UAInspector.Downloader for more details. User Agent Parsing iex&gt; UAInspector . parse ( &quot;Mozilla/5.0 (iPad; CPU OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53&quot; ) % UAInspector.Result { client : % UAInspector.Result.Client { engine : &quot;WebKit&quot; , engine_version : &quot;537.51.1&quot; , name : &quot;Mobile Safari&quot; , type : &quot;browser&quot; , version : &quot;7.0&quot; } , device : % UAInspector.Result.Device { brand : &quot;Apple&quot; , model : &quot;iPad&quot; , type : &quot;tablet&quot; } , os : % UAInspector.Result.OS { name : &quot;iOS&quot; , platform : :unknown , version : &quot;7.0.4&quot; } , user_agent : &quot;Mozilla/5.0 (iPad; CPU OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53&quot; } iex&gt; UAInspector . parse ( &quot;Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36&quot; ) % UAInspector.Result.Bot { category : &quot;Search bot&quot; , name : &quot;Googlebot&quot; , producer : % UAInspector.Result.BotProducer { name : &quot;Google Inc.&quot; , url : &quot;http://www.google.com&quot; } , url : &quot;http://www.google.com/bot.html&quot; , user_agent : &quot;Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36&quot; } Full documentation is available inline in the UAInspector module and at https://hexdocs.pm/ua_inspector .","ref":"readme.html#basic-usage","title":"Overview - Basic Usage","type":"extras"},{"doc":"Several (minimal) benchmark scripts are included. Please refer to the Mixfile or mix help output for their names.","ref":"readme.html#benchmark","title":"Overview - Benchmark","type":"extras"},{"doc":"matomo-org/device-detector","ref":"readme.html#resources","title":"Overview - Resources","type":"extras"},{"doc":"Copyright (c) 2013 Marc Neudert Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. The parser databases are taken from the matomo-org/device-detector project. See there for detailed license information about the data contained.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]